<?php

function info_searchform()
{
  global $cfg;
  global $zlist;

  $replace = array('basepath' => $cfg['basepath'],
		   'keyword' => $zlist['keyword']);

  return load_javascript('searchform.js') . load_template('searchform.html', $replace);
}

function info_new()
{
  global $cfg;

  if ($cfg['path'] == 'reply.html' ||
      $cfg['path'] == 'topic.html' ||
      $cfg['path'] == 'new.html' ||
      $cfg['dir'] == 'zeitung')
    return;

  $query = "SELECT name,id FROM zeitungen " .
           "WHERE changed > now() - interval '3 months' AND deleted IS false " .
           "ORDER BY changed DESC limit 10";

  $sth = db_query($query);

  if (pg_NumRows ($sth) == 0)
    return;

  $ret = '<h3>Neu aufgenommen</h3>';
  $ret .= '<p><ul>';
  for ($n=0; $n < pg_NumRows ($sth); $n++) {
    $row = pg_fetch_array ($sth, $n);
    $ret .= sprintf('<li><a href="%szeitung/%d.html">%s</a></li>',
		    $cfg['basepath'], $row['id'], $row['name']);
  }
  $ret .= '</ul></p>';

  return $ret;
}

function info_topten()
{
  global $cfg;

  $query = "SELECT zeitung,name,sum(counter) as counter FROM hits " .
           "INNER JOIN zeitungen ON id = zeitung " .
           "WHERE deleted IS false " .
           "GROUP BY zeitung,name ORDER BY counter DESC LIMIT 10";

  $sth = db_query($query) or carp("info_topten");

  if (pg_NumRows ($sth) == 0)
    return;

  $ret = '<h3>Top 10</h3>';
  $ret .= '<p><ul>';
  for ($n=0; $n < pg_NumRows ($sth); $n++) {
    $row = pg_fetch_array ($sth, $n);
    $ret .= sprintf('<li><a href="%szeitung/%d.html">%s</a></li>',
		    $cfg['basepath'], $row['zeitung'], $row['name']);
  }
  $ret .= '</ul></p>';

  return $ret;
}

function info_hitlist()
{
  global $cfg;
  global $_SESSION;

  if (!isset($_SESSION['uid']))
    return info_topten();

  $query = sprintf("SELECT zeitung,name,counter FROM hits " .
		   "INNER JOIN zeitungen ON id = zeitung " .
		   "WHERE deleted IS false AND uid = %d " .
		   "ORDER BY counter DESC LIMIT 10", $_SESSION['uid']);

  $sth = db_query($query) or carp("info_topten");

  if (pg_NumRows ($sth) == 0)
    return info_topten();

  $ret = '<h3>Favoriten</h3>';
  $ret .= '<p><ul>';
  for ($n=0; $n < pg_NumRows ($sth); $n++) {
    $row = pg_fetch_array ($sth, $n);
    $ret .= sprintf('<li><a href="%szeitung/%d.html">%s</a></li>',
		    $cfg['basepath'], $row['zeitung'], $row['name']);
  }
  $ret .= '</ul></p>';

  return $ret;
}

function info_tags()
{
  global $cfg;
  global $zlist;

  if (!isset($zlist['zid']))
    return;

  $query = sprintf("SELECT id,tagname,count(uid) AS count " .
		   "FROM tags JOIN zeitung_tags ON tag = id " .
		   "WHERE zeitung = %d GROUP BY id,tagname " .
		   "ORDER BY lower(tagname)",
		   $zlist['zid']);

  $sth = db_query($query);

  if (pg_NumRows ($sth) == 0)
    return;

  $ret = '<h3>Tags</h3>';
  $ret .= '<p class="tagcloud">';
  for ($n=0; $n < pg_NumRows ($sth); $n++) {
    $row = pg_fetch_array ($sth, $n);

    $ret .= sprintf('<span class="tag%d"><a href="%stag/%s.html">%s</a></span> ',
		    tag_class($row['count']), $cfg['basepath'],
		    urlencode($row['tagname']), $row['tagname']);
  }
  $ret .= '</p>';

  return $ret;
}

function info_tagcloud()
{
  global $cfg;
  global $zlist;
  global $_SESSION;

  if (!isset($zlist['zid']))
    return;

  if (!is_numeric($_SESSION['uid']))
    return;

  $query = sprintf("SELECT id,tagname FROM tags " .
		   "JOIN zeitung_tags ON tag = id " .
		   "WHERE zeitung = %d AND uid = %d " .
		   "ORDER BY lower(tagname)",
		   $zlist['zid'], $_SESSION['uid']);

  $sth = db_query($query);

  if (pg_NumRows ($sth) == 0)
    return info_tags();

  $ret = '<h3>Persönliche Tags</h3>';
  $ret .= '<p class="tagcloud">';
  for ($n=0; $n < pg_NumRows ($sth); $n++) {
    $row = pg_fetch_array ($sth, $n);

    $ret .= sprintf('<span class="tag0"><a href="%stag/%s.html">%s</a></span> ',
		    $cfg['basepath'],
		    $row['tagname'], $row['tagname']);
  }
  $ret .= '</p>';

  return $ret;
}

function info_archive($zid)
{
  global $cfg;

  $query = sprintf('SELECT count(*) FROM topics '.
		   'WHERE zeitung = %d AND archived IS true',
		   $zid);

  $sth = db_query($query);

  $row = pg_fetch_array($sth, 0);

  if ($row[0] > 0)
    return sprintf('<img src="%sarchive.gif" width="27" height="20" alt="">&nbsp;' .
		   '<a href="%sarchiv/%d.html"><strong>Archiv</strong></a>',
		   $cfg['basepath'], $cfg['basepath'], $zid);

    return false;
}

function info_actions()
{
  global $cfg;
  global $zlist;
  global $_SESSION;

  $title = array('edit' => 'Stammdaten dieser Zeitung bearbeiten',
		 'tags' => 'Persönliche Tags zur Zeitung hinzufügen oder löschen',
		 'add' => 'Neue Zeitung oder Magazin aufnehmen',
		 'newtopic' => 'Neue Diskussion zu dieser Zeitung beginnen',
		 'bookmark' => 'Lesezeichen zu dieser Zeitung setzen',
		 'bookmarks' => 'Persönliche Lesezeichen verwalten',
		 );

  $actions = array();
  $ret = '';

  if (isset($_SESSION['uid']) && $cfg['path'] == 'options.html')
    $actions[] = sprintf('<img src="%spasswd.gif" width="27" height="23" alt="">&nbsp;' .
			 '<a href="%spasswd.html"><strong>Passwort ändern</strong></a>',
			 $cfg['basepath'], $cfg['basepath']);

  if (($cfg['dir'] == 'zeitung' || $cfg['dir'] == 'archiv' || $cfg['dir'] == 'topic' ) &&
      isset($zlist['zid'])) {
    if (isset($_SESSION['uid']))
      $actions[] = sprintf('<img src="%stag.gif" width="27" height="25" alt="">&nbsp;' .
			   '<a href="%stags.html?zeitung=%d" title="%s"><strong>Tags verwalten</strong></a>',
			   $cfg['basepath'], $cfg['basepath'], $zlist['zid'],
			   $title['tags']);
    else
      $actions[] = sprintf('<img src="%stag.gif" width="27" height="25" alt="">&nbsp;' .
			   '<a href="%slogin.html?from=tags" title="%s"><strong>Tags verwalten</strong></a>',
			   $cfg['basepath'], $cfg['basepath'], $title['tags']);
  }

  if ($cfg['dir'] == 'zeitung' && isset($_SESSION['uid'])) {
    if (javascript_ok()) {
      
      $ret .= load_javascript('bookmarks.js');
      $link = sprintf('href="%sbookmark.html" onclick="return bookmark_action(\'add\',%d);"',
		      $cfg['basepath'], $zlist['zid']);
    } else
      $link = sprintf('href="%sbookmark.html?zeitung=%d"', $cfg['basepath'], $zlist['zid']);

    $actions[] = sprintf('<img src="%sadd.gif" width="27" height="24" alt="">&nbsp;' .
			 '<a %s title="%s"><strong>Lesezeichen setzen</strong></a>',
			 $cfg['basepath'], $link,
			 $title['bookmark']);
  }

  if ($cfg['path'] == 'options.html' && isset($_SESSION['uid']))
    $actions[] = sprintf('<img src="%sbookmarks.gif" width="27" height="21" alt="">&nbsp;' .
			 '<a href="%sbookmark.html" title="%s"><strong>Lesezeichen verwalten</strong></a>',
			 $cfg['basepath'], $cfg['basepath'],
			 $title['bookmarks']);

  if ($cfg['dir'] == 'zeitung' && isset($zlist['zid'])) {
    if (isset($_SESSION['uid']))
      $actions[] = sprintf('<img src="%sedit.gif" width="27" height="26" alt="">&nbsp;' .
			   '<a href="%sedit.html?zeitung=%d" title="%s"><strong>Bearbeiten</strong></a>',
			   $cfg['basepath'], $cfg['basepath'], $zlist['zid'],
			   $title['edit']);
    else
      $actions[] = sprintf('<img src="%sedit.gif" width="27" height="26" alt="">&nbsp;' .
			   '<a href="%slogin.html?from=edit" title="%s"><strong>Bearbeiten</strong></a>',
			   $cfg['basepath'], $cfg['basepath'],
  			   $title['edit']);
  }

  if ($zlist['page'] == 'index' ||
      $cfg['dir'] == 'zeitung' ||
      $cfg['dir'] == 'tag') {
    if (isset($_SESSION['uid']))
      $actions[] = sprintf('<img src="%snewspaper.gif" width="27" height="25" alt="">&nbsp;' .
			   '<a href="%snew.html" title="%s"><strong>Neue Zeitung</strong></a>',
			   $cfg['basepath'], $cfg['basepath'], $title['add']);
    else
      $actions[] = sprintf('<img src="%snewspaper.gif" width="27" height="25" alt="">&nbsp;' .
			   '<a href="%slogin.html?from=new" title="%s"><strong>Neue Zeitung</strong></a>',
			   $cfg['basepath'], $cfg['basepath'], $title['add']);
  }

  if ($zlist['notopic'] === true)
    $text = 'Diskussion';
  else
    $text = 'Neues Thema';

  if (($cfg['dir'] == 'zeitung' || $cfg['dir'] == 'archiv') && isset($zlist['zid'])) {
    if (isset($_SESSION['uid']))
      $actions[] = sprintf('<img src="%snewtopic.gif" width="27" height="20" alt="">&nbsp;' .
			   '<a href="%stopic.html?zeitung=%d" title="%s"><strong>%s</strong></a>',
			   $cfg['basepath'], $cfg['basepath'], $zlist['zid'],
			   $title['newtopic'], $text);
    else
      $actions[] = sprintf('<img src="%snewtopic.gif" width="27" height="20" alt="">&nbsp;' .
			   '<a href="%slogin.html?from=zeitung" title="%s"><strong>%s</strong></a>',
			   $cfg['basepath'], $cfg['basepath'], $title['newtopic'], $text);
  }

  if ($cfg['dir'] == 'zeitung' && isset($zlist['zid'])) {
    $try = info_archive($zlist['zid']);
    if ($try !== false)
      $actions[] = $try;
  }

  if ($actions) {
    $ret .= '<p><ul class="action">';
    foreach ($actions as $row)
      $ret .= '<li>' . $row . '</li>';
    $ret .= '</ul></p>';
  }

  return $ret;
}

function info_bookmarks()
{
  global $cfg;
  global $_SESSION;

  if (!isset($_SESSION['uid']))
    return;

  if ($cfg['path'] == 'bookmark.html')
    return;

  $try = format_info_bookmarks();

  if ($try === false)
    return;

  $ret = '<h3>Lesezeichen</h3>';
  $ret .= '<div id="bookmarks">';
  $ret .= $try;
  $ret .= '</div>';

  return $ret;
}


?>